/*
 * stepper.h
 *
 * Created: 2/17/2018 5:39:45 PM
 *  Author: Jake
 */ 


#ifndef STEPPER_H_
#define STEPPER_H_

#include "sam.h"
#include "pin.h"

typedef struct {
	pin_t *step_pin;
	pin_t *dir_pin;
	
	// tracking time periods
	unsigned long one_minute;
	unsigned long speed_period;
	unsigned long accel_period;
	
	// tracking time for updates
	unsigned long last_step;
	unsigned long last_accel;
	
	// have to track speed to update accel
	uint32_t speed;
	
	// targets
	uint32_t position_ticks;
	uint32_t position_accel_to;
	uint32_t position_deccel_from;
	uint32_t position_ticks_end;
}stepper_t;

stepper_t stepper_new(pin_t *step_pin, pin_t *dir_pin);

void stepper_reset(stepper_t *stepper);

// steps discrete, mm/min
void stepper_steps(stepper_t *stepper, int32_t steps, uint32_t speed);

// steps discrete, mm/min, mm/min/s (mm/s better but we want more discrete resolution)
void stepper_block(stepper_t *stepper, int32_t steps, uint32_t entryspeed, uint32_t accel, uint32_t accellength, uint32_t deccellength);

void stepper_update(stepper_t *stepper);

/*
step to-do
 - everything is broken and untested
 - refactor all for:
  - dir-by-flag, assume no dir change per segment
  - speed & periods unfuck
  - update checks accel rate as well
*/

#endif /* STEPPER_H_ */